> ## Documentation Index
> Fetch the complete documentation index at: https://algolia.com/llms.txt
> Use this file to discover all available pages before exploring further.

# voiceSearch

> Lets users submit search queries using voice input.

export const SearchQuery = () => <Tooltip tip="The text users enter into a search box. In the Search API, this corresponds to the query parameter. A search query is often used with filters, facets, and other parameters, but these aren't part of the query text itself.">
    search query
  </Tooltip>;

```ts Signature theme={"system"}
voiceSearch({
  container: string | HTMLElement,
  // Optional parameters
  searchAsYouSpeak?: boolean,
  language?: string,
  additionalQueryParameters?: object,
  templates?: object,
  cssClasses?: object,
});
```

## Import

<CodeGroup>
  ```js Package manager theme={"system"}
  import { voiceSearch } from "instantsearch.js/es/widgets";
  ```

  ```js CDN theme={"system"}
  const { voiceSearch } = instantsearch.widgets;
  // or directly use instantsearch.widgets.voiceSearch()
  ```
</CodeGroup>

<Card title="See this widget in action" icon="monitor-play" href="https://instantsearchjs.netlify.app/stories/js/?path=/story/basics-voicesearch--default" horizontal>
  Preview this widget and its behavior.
</Card>

## About this widget

The `voiceSearch` widget lets users perform a voice-based <SearchQuery />.

It uses the [Web Speech API](https://w3c.github.io/speech-api),
which only Chrome (from version 25) has implemented so far.
This means the `voiceSearch` widget only works on desktop Chrome and Android Chrome.
It doesn't work on iOS Chrome, which uses the iOS WebKit.

## Examples

```js JavaScript icon=code theme={"system"}
voiceSearch({
  container: "#voicesearch",
});
```

## Options

<ParamField body="container" type="string | HTMLElement" required>
  The CSS Selector or `HTMLElement` to insert the widget into.

  <CodeGroup>
    ```js string theme={"system"}
    voiceSearch({
      container: "#voicesearch",
    });
    ```

    ```js HTMLElement theme={"system"}
    voiceSearch({
      container: document.querySelector("#voicesearch"),
    });
    ```
  </CodeGroup>
</ParamField>

<ParamField body="searchAsYouSpeak" type="boolean" default={false}>
  Whether to trigger the search as you speak.
  If `false`, search is triggered only after speech is finished.
  If `true`, search is triggered whenever the engine delivers an interim transcript.

  ```js JavaScript icon=code theme={"system"}
  voiceSearch({
    // ...
    searchAsYouSpeak: true,
  });
  ```
</ParamField>

<ParamField body="language" type="string" default="all languages">
  The language you want your `voiceSearch` widget to recognize.
  The default (`all languages`) can result in false positives.
  For example, an English word you pronounce might be recognized as a French word,
  which can cause irrelevant results.
  Make sure to give a [BCP 47 language tag](https://en.wikipedia.org/wiki/IETF_language_tag),
  like `en-US` or `fr-FR`.
  This language is automatically forwarded to the [`queryLanguages`](/doc/api-reference/api-parameters/queryLanguages) query parameter.

  ```js JavaScript icon=code theme={"system"}
  voiceSearch({
    // ...
    language: "en-US",
  });
  ```
</ParamField>

<ParamField body="additionalQueryParameters" type="function">
  A function that receives the current query and returns the list of [search parameters](/doc/api-reference/search-api-parameters) you want to enable for voice search.

  By default, the following query parameters are set:

  * [`ignorePlurals`](/doc/api-reference/api-parameters/ignorePlurals) to `true`
  * [`removeStopWords`](/doc/api-reference/api-parameters/removeStopWords) to `true`
  * [`optionalWords`](/doc/api-reference/api-parameters/optionalWords) to the current query

  To disable this behavior, override the return value of `additionalQueryParameters`.

  ```js JavaScript icon=code theme={"system"}
  voiceSearch({
    // ...
    additionalQueryParameters(query) {
      return {
        ignorePlurals: false,
      };
    },
  });
  ```
</ParamField>

<ParamField body="templates" type="object">
  The [templates](#templates) to use for the widget.

  ```js JavaScript icon=code theme={"system"}
  voiceSearch({
    // ...
    templates: {
      // ...
    },
  });
  ```
</ParamField>

<ParamField body="cssClasses" type="object">
  The [CSS classes you can override](/doc/guides/building-search-ui/widgets/customize-an-existing-widget/js#style-your-widgets):

  * `root`. The root element of the widget.
  * `button`. The button element.
  * `status`. The status element.

  ```js JavaScript icon=code theme={"system"}
  voiceSearch({
    // ...
    cssClasses: {
      root: "MyCustomVoiceSearch",
      button: [
        "MyCustomVoiceSearchButton",
        "MyCustomVoiceSearchButton--subclass",
      ],
      status: [
        "MyCustomVoiceSearchStatus",
        "MyCustomVoiceSearchStatus--subclass",
      ],
    },
  });
  ```
</ParamField>

## Templates

You can customize parts of a widget’s UI using the Templates API.

Each template includes an `html` function,
which you can use as a [tagged template](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Template_literals#tagged_templates).
This function safely renders templates as HTML strings and works directly in the browser—no build step required.
For details, see [Templating your UI](/doc/guides/building-search-ui/widgets/customize-an-existing-widget/js/#templating-your-ui).

<Note>
  The `html` function is available in InstantSearch.js version 4.46.0 or later.
</Note>

<ParamField body="buttonText" type="string | function">
  The template used for displaying the button.

  <CodeGroup>
    ```js function theme={"system"}
    voiceSearch({
      // ...
      templates: {
        buttonText(
          {
            isListening,
            status,
            errorCode,
            transcript,
            isSpeechFinal,
            isBrowserSupported,
          },
          { html },
        ) {
          return html`<span>${isListening ? "Stop" : "Start"}</span>`;
        },
      },
    });
    ```

    ```js string theme={"system"}
    // String-based templates are deprecated, use functions instead.
    voiceSearch({
      // ...
      templates: {
        buttonText: "🎙",
      },
    });
    ```
  </CodeGroup>
</ParamField>

<ParamField body="status" type="string | function">
  The template used for displaying the status.

  <CodeGroup>
    ```js function theme={"system"}
    voiceSearch({
      // ...
      templates: {
        status(
          {
            isListening,
            status,
            errorCode,
            transcript,
            isSpeechFinal,
            isBrowserSupported,
          },
          { html },
        ) {
          const className = isListening ? "listening" : "not-listening";
          return html`
            <div class="${className}">
              <span>${transcript ? transcript : ""}</span>
            </div>
          `;
        },
      },
    });
    ```

    ```js string theme={"system"}
    // String-based templates are deprecated, use functions instead.
    voiceSearch({
      // ...
      templates: {
        status: `
          <p>status: {{status}}</p>
          <p>errorCode: {{errorCode}}</p>
          <p>isListening: {{isListening}}</p>
          <p>transcript: {{transcript}}</p>
          <p>isSpeechFinal: {{isSpeechFinal}}</p>
          <p>isBrowserSupported: {{isBrowserSupported}}</p>
        `,
      },
    });
    ```
  </CodeGroup>
</ParamField>

## HTML output

```html HTML icon=code-xml theme={"system"}
<div class="ais-VoiceSearch">
  <button class="ais-VoiceSearch-button" type="button" title="Search by voice">
    ...
  </button>
  <div class="ais-VoiceSearch-status">...</div>
</div>
```

## Customize the UI with `connectVoiceSearch`

If you want to create your own UI of the `voiceSearch` widget, you can use connectors.

To use `connectVoiceSearch`, you can import it with the declaration relevant to how you installed InstantSearch.js.

<CodeGroup>
  ```js Package manager theme={"system"}
  import { connectVoiceSearch } from "instantsearch.js/es/connectors";
  ```

  ```js CDN theme={"system"}
  const { connectVoiceSearch } = instantsearch.connectors;
  // or directly use instantsearch.connectors.connectVoiceSearch()
  ```
</CodeGroup>

Then it's a 3-step process:

```js JavaScript icon=code theme={"system"}
// 1. Create a render function
const renderVoiceSearch = (renderOptions, isFirstRender) => {
  // Rendering logic
};

// 2. Create the custom widget
const customVoiceSearch = connectVoiceSearch(renderVoiceSearch);

// 3. Instantiate
search.addWidgets([
  customVoiceSearch({
    // instance params
  }),
]);
```

### Create a render function

This rendering function is called before the first search (`init` lifecycle step)
and each time results come back from Algolia (`render` lifecycle step).

```js JavaScript icon=code theme={"system"}
const renderVoiceSearch = (renderOptions, isFirstRender) => {
  const {
    isBrowserSupported,
    isListening,
    toggleListening,
    voiceListeningState,
    widgetParams,
  } = renderOptions;

  if (isFirstRender) {
    // Do some initial rendering and bind events
  }

  // Render the widget
};
```

#### Render options

<ParamField body="isBrowserSupported" type="boolean">
  `true` if user's browser supports voice search.

  ```js JavaScript icon=code theme={"system"}
  const renderVoiceSearch = (renderOptions, isFirstRender) => {
    const { isBrowserSupported } = renderOptions;

    const container = document.querySelector("#voicesearch");

    if (isFirstRender && !isBrowserSupported) {
      const message = document.createElement("p");
      message.innerText = "This browser is not supported.";
      container.appendChild(message);
    }
  };
  ```
</ParamField>

<ParamField body="toggleListening" type="function">
  Starts listening to user's speech, or stops it if already listening.

  ```js JavaScript icon=code theme={"system"}
  const renderVoiceSearch = (renderOptions, isFirstRender) => {
    const { toggleListening } = renderOptions;

    const container = document.querySelector("#voicesearch");

    if (isFirstRender) {
      const button = document.createElement("button");
      button.textContent = "Toggle";

      button.addEventListener("click", (event) => {
        toggleListening();
      });

      container.appendChild(button);
    }
  };
  ```
</ParamField>

<ParamField body="isListening" type="boolean">
  `true` if listening to user's speech.

  ```js JavaScript icon=code theme={"system"}
  const renderVoiceSearch = (renderOptions, isFirstRender) => {
    const { isListening, toggleListening } = renderOptions;

    const container = document.querySelector("#voicesearch");

    if (isFirstRender) {
      const button = document.createElement("button");
      button.textContent = "Toggle";

      button.addEventListener("click", (event) => {
        toggleListening();
      });

      container.appendChild(button);
    }

    container.querySelector("button").textContent = isListening
      ? "Stop"
      : "Start";
  };
  ```
</ParamField>

<ParamField body="voiceListeningState" type="boolean">
  An object containing the following states regarding speech recognition:

  * `status: string`. Current status (`initial`|`askingPermission`| `waiting`|`recognizing`|`finished`|`error`).
  * `transcript: string`. Currently recognized transcript.
  * `isSpeechFinal: boolean`. `true` if speech recognition is finished.
  * `errorCode: string | undefined`. An error code (if any).
    Refer to the [spec](https://w3c.github.io/speech-api/#speechreco-error) for more information.

  ```js JavaScript icon=code theme={"system"}
  const renderVoiceSearch = (renderOptions, isFirstRender) => {
    const { voiceListeningState, toggleListening } = renderOptions;
    const { status, transcript, isSpeechFinal, errorCode } = voiceListeningState;

    const container = document.querySelector("#voicesearch");

    if (isFirstRender) {
      const state = document.createElement("div");
      state.innerHTML = `
        <p>status : <span class="status"></span></p>
        <p>transcript : <span class="transcript"></span></p>
        <p>isSpeechFinal : <span class="is-speech-final"></span></p>
        <p>errorCode : <span class="error-code"></span></p>
      `;
      container.appendChild(state);

      const button = document.createElement("button");
      button.textContent = "Toggle";
      button.addEventListener("click", (event) => {
        toggleListening();
      });
      container.appendChild(button);
    }
    container.querySelector(".status").innerText = status;
    container.querySelector(".transcript").innerText = transcript;
    container.querySelector(".is-speech-final").innerText = isSpeechFinal;
    container.querySelector(".error-code").innerText = errorCode || "";
  };
  ```
</ParamField>

<ParamField body="widgetParams" type="object">
  All original widget options forwarded to the render function.

  ```js JavaScript icon=code theme={"system"}
  const renderVoiceSearch = (renderOptions, isFirstRender) => {
    const { widgetParams } = renderOptions;

    widgetParams.container.innerHTML = "...";
  };

  const customVoiceSearch = connectVoiceSearch(renderVoiceSearch);

  search.addWidgets([
    customVoiceSearch({
      container: document.querySelector("#voicesearch"),
    }),
  ]);
  ```
</ParamField>

### Create and instantiate the custom widget

First, create your custom widgets using a rendering function.
Then, instantiate them with parameters.

There are two kinds of parameters you can pass:

* **Instance parameters**. Predefined options that configure Algolia's behavior.
* **Custom parameters**. Parameters you define to make the widget reusable and adaptable.

Inside the `renderFunction`, both instance and custom parameters are accessible through `connector.widgetParams`.

```js JavaScript icon=code theme={"system"}
const customVoiceSearch = connectVoiceSearch(
  renderVoiceSearch
);

search.addWidgets([
  customVoiceSearch({
    // Optional parameters
    searchAsYouSpeak?: boolean,
  })
]);
```

#### Instance options

<ParamField body="searchAsYouSpeak" type="boolean" default={false}>
  Whether to trigger the search as you speak.
  If `false`, search is triggered only after speech is finished.
  If `true`, search is triggered as many times as the engine delivers an interim transcript.

  ```js JavaScript icon=code theme={"system"}
  customVoiceSearch({
    searchAsYouSpeak: true,
  });
  ```
</ParamField>

<ParamField body="language" type="string" default="all languages">
  The language you want your `voiceSearch` widget to recognize.
  The default (`all languages`) can result in false positives.
  For example, an English word you pronounce might be recognized as a French word,
  which can cause irrelevant results.
  Make sure to give a [BCP 47 language tag](https://en.wikipedia.org/wiki/IETF_language_tag),
  like `en-US` or `fr-FR`.
  This language is automatically forwarded to the [`queryLanguages`](/doc/api-reference/api-parameters/queryLanguages) query parameter.

  ```js JavaScript icon=code theme={"system"}
  customVoiceSearch({
    // ...
    language: "en-US",
  });
  ```
</ParamField>

<ParamField body="additionalQueryParameters" type="function">
  A function that receives the current query and returns the list of [search parameters](/doc/api-reference/search-api-parameters) you want to enable for voice search.

  By default, the following query parameters are set:

  * [`ignorePlurals`](/doc/api-reference/api-parameters/ignorePlurals) to `true`
  * [`removeStopWords`](/doc/api-reference/api-parameters/removeStopWords) to `true`
  * [`optionalWords`](/doc/api-reference/api-parameters/optionalWords) to the current query

  To disable this behavior, override the return value of `additionalQueryParameters`.

  ```js JavaScript icon=code theme={"system"}
  customVoiceSearch({
    // ...
    additionalQueryParameters(query) {
      return {
        ignorePlurals: false,
      };
    },
  });
  ```
</ParamField>

### Full example

<CodeGroup>
  ```html HTML theme={"system"}
  <div id="voicesearch"></div>
  ```

  ```js JavaScript theme={"system"}
  // Create a render function
  const renderVoiceSearch = (renderOptions, isFirstRender) => {
    const { isListening, toggleListening, voiceListeningState } = renderOptions;

    const container = document.querySelector("#voicesearch");

    if (isFirstRender) {
      const button = document.createElement("button");
      button.addEventListener("click", (event) => {
        toggleListening();
      });
      container.appendChild(button);

      const state = document.createElement("pre");
      container.appendChild(state);
    }

    container.querySelector("button").textContent = isListening
      ? "Stop"
      : "Start";

    container.querySelector("pre").textContent = JSON.stringify(
      voiceListeningState,
      null,
      2,
    );
  };

  // create custom widget
  const customVoiceSearch = connectVoiceSearch(renderVoiceSearch);

  // instantiate custom widget
  search.addWidgets([
    customVoiceSearch({
      container: document.querySelector("#voicesearch"),
    }),
  ]);
  ```
</CodeGroup>
